
				; Note: xxPressed values must follow the
				; respective xxStatus
joyStatus:	db 	#FF	; Current joystick/kbdJoy button status
joyPressed:	db	#FF	; Same as joyStatus, but detects each press
joyPressedGam:	db	#FF	; Same as joyPressed, but used in gameplay
				; to detect individual presses inside each
				; hero move cycle
fnBtnStatus:	db	#FF	; STOP,TAB,ESC,F5,F4,F3,F2,F1
fnBtnPressed:	db	#FF	; Same as fnBtnStatus, but detects each press
kbdRow4Status:	db	#FF	; Keyboard row4
jport1HIDprot:	db	#FF	; joyport1 MSX-HID protocol ID
jport2HIDprot:	db	#FF	; joyport2 MSX-HID protocol ID

;satBackBuf:	db	#1B	; SAT back-buffer address 
is60:		db	0
mpframes:	db	0	; Music Player frames
gmframes:	db	0	; Game loop frames
mpbusy:		db	0	; Music player busy flag


deadCount: 	db	0	; Timer to keep the game running after a death
timer:		dw	0	; 16bit timer
timerVbl:	db	0	; Cowntown timer, used only to wait for Vblank
xrnd16Seed:	dw	0	; Seed for the 16bit random generator
rndEntropy:	db	0	; Entropy to help the RND generator 

gameState:	db	0	; GS_GAMEPLAY
gameSubState:	db	0	; GSS_GAMEPLAY_INTERACT
currentLevel:	db	0
curShowFX:	dw	0	; Current showLevel effect
curShowEnemy:	dw	0	; Current showLevel enemy
demoLevel:	db	0	; Level to use on the demoplay
demoTimer:	dw	0	; Countdouwn timer to end the demo

fireFrame:	db	0
fireDelay:	db	0
goldDelay:	db	0
totalGold:	db	0
outroDelay:	db	0
outroString:	dw	outroText
outroCount:	db	0

walkSoundCount:	db	0
mostSoundCount:	db	0


gameFlags:	db	0	; Bunch of flags for the game 
.skipd		equ	0	; bitmask



statusText:
		db 0,0," LEVEL: XX PICKAXE: 00 GOLD: 00 ",255

spritesTable: block (MAXENEMIES+1)*VDPSPR
spritePtr:	dw	0

;=========== HERO RAMS ======================
heroGold:		db	0
heroPickaxe:		db	0
heroLives:		db	0	; Number of lives

hero OBJHERO

;============ BLOCKS/BRICKS RAM =================
blockFrame:		db	0
blockTick:		dw	0
blockDelay:		db	0
blockCoords:		dw	00000

;============ ENEMIES RAM =================
ttt2:			db	0
enemyDelay:		db	0

enemiesList:
    block MAXENEMIES*OBJENEMY

;============ BRIDGE RAM ===================
bridgeDirection:	db	0
bridgePosition:		dw	00000
bridgeMapPosition:	dw	00000
bridgeDelay:		db	0
bridgeFace:		db	0


;============ MINES RAM =====================
minesPointer:		dw	minesList
; Kabum - only one mine per level at a time

kabumScr:		dw	00000
kabumMap:		dw	00000
kabumCoords:		dw	00000

kabumCount:		dw	0
kabumDelay:		db	0

globalMineDelay:	db	0

minesList:		;list of all mines cycle
			block MAXMINES*OBJENEMY
        		;mark of end list
       			db	255
;======File related routines and variables ======
filename:	ds	11
	EZFILELIB.macro_placeDskErrRamHdlHere

oldHTIMI:		ds	5

