; Mines part and kabum

 STRUCT OBJMINE
counter		db	0	; 0=mine is not active
xPos		db	0
yPos		db	0
mapaddr		dw	0
delay		db	0
 ENDS

resetMines:
    xor a : ld (kabumCount),a

    ld hl,minesList
    ld (minesPointer),hl
    ld de,minesList+1
    ld bc,MAXMINES*OBJMINE-1
    ld (hl),0

    ;end mark
    ld a,255 : ld (minesList+MAXMINES*OBJMINE),a
    ldir

    ld a,1 : ld (kabumDelay),a

    ret

doKabum:
    ld a,(kabumDelay) : xor 1 : ld (kabumDelay),a
    or a : ret nz

    ld a,(kabumCount)
    or a
    ret z
    dec a
    ld (kabumCount),a
    ;ok kabum is active
    ;manual animate all 8 steps %)
    ;HARD CODE
    
    cp 8
    jr nz,1f
    
    ld de,(kabumCoords) : ld a,33 : call fillTile
    ld de,(kabumCoords) : inc e : ld a,32 : call fillTile
    ld de,(kabumCoords) : dec e : ld a,32 : call fillTile
    ;ld hl,(kabumScr) : ld (kabumAddr+1),hl
    ;down 8 - !!!!!!!!!!!!!!!! rewrite
    ;dup 7: inc h : edup : call downHL : ld (kabumScr),hl
    ret
1:

    cp 7
    jp nz,1f
    ld de,(kabumCoords) : ld a,34 : call fillTile
    ld de,(kabumCoords) : inc e : ld a,33 : call fillTile
    ld de,(kabumCoords) : dec e : ld a,33 : call fillTile
    ;clear line and move down
	ld	iy,(kabumMap)
	xor	a
	ld	(iy-33),a
	ld	(iy-32),a
	ld	(iy-31),a
	ld	(iy-1),a
	ld	(iy),a
	ld	(iy+1),a
    ld bc,32 : add iy,bc : ld (kabumMap),iy
    ;second
    ld de,(kabumCoords) : inc d : ld a,33 : call fillTile
    ld de,(kabumCoords) : inc d : inc e : ld a,32 : call fillTile
    ld de,(kabumCoords) : inc d : dec e : ld a,32 : call fillTile
    ;down 8 - !!!!!!!!!!!!!!!! rewrite

    ;third
    ld de,(kabumCoords) : dec d : ld a,33 : call fillTile
    ld de,(kabumCoords) : dec d : ld a,32 : call fillTile
    ld de,(kabumCoords) : dec d : dec e : ld a,32 : call fillTile
    ret
1:

    cp 6
    jr nz,1f
    ld de,(kabumCoords) : ld a,0 : call fillTile
    ld de,(kabumCoords) : inc e : ld a,34 : call fillTile
    ld de,(kabumCoords) : dec e : ld a,34 : call fillTile
    ;second
    ld de,(kabumCoords) : inc d : ld a,34 : call fillTile
    ld de,(kabumCoords) : inc d : inc e :ld a,33 : call fillTile
    ld de,(kabumCoords) : inc d : dec e : ld a,33 : call fillTile
     ;clear line and move down
	ld	iy,(kabumMap)
	xor	a
	ld	(iy-1),a
	ld	(iy),a
	ld	(iy+1),a
    ld bc,32 : add iy,bc : ld (kabumMap),iy
    
    ;third
    ld de,(kabumCoords) : dec d : ld a,34 : call fillTile
    ld de,(kabumCoords) : dec d : inc e : ld a,33 : call fillTile
    ld de,(kabumCoords) : dec d : dec e : ld a,33 : call fillTile
    
    ret
1:

    cp 5
    jr nz,1f
    ld de,(kabumCoords) : xor a : call fillTile
    ld de,(kabumCoords) : inc e : xor a : call fillTile
    ld de,(kabumCoords) : dec e : xor a : call fillTile

;second
    ld de,(kabumCoords) : inc d : xor a : call fillTile
    ld de,(kabumCoords) : inc d : ld a,34 : call fillTile
    ld de,(kabumCoords) : inc d : dec e : ld a,34 : call fillTile
;third
    ld de,(kabumCoords) : dec d : xor a : call fillTile
    ld de,(kabumCoords) : dec d : inc e : ld a,34 : call fillTile
    ld de,(kabumCoords) : dec d : dec e : ld a,34 : call fillTile
    ret
1:

    cp 4
    jr nz,1f
    ;second
    ld de,(kabumCoords) : inc d : xor a : call fillTile
    ld de,(kabumCoords) : inc d : inc e : xor a : call fillTile
    ld de,(kabumCoords) : inc d : dec e : xor a : call fillTile

    ;third
    ld de,(kabumCoords) : dec d : xor a : call fillTile
    ld de,(kabumCoords) : dec d : inc e : xor a : call fillTile
    ld de,(kabumCoords) : dec d : dec e : xor a : call fillTile
    ret
1:

    cp 3
    jr nz,1f
    ret
1:

    cp 2
    jr nz,1f
    ret
1:

    cp 1
    jr nz,1f
    ret
1:

    ret

;   de - coords of center
;   hl - addr in map of center
initKabum:
    ;init counter
    ld a,10 : ld (kabumCount),a
    ld (kabumMap),hl : ld (hl),0
    push de
    ld (kabumCoords),de :  ld a,32 : call fillTile
    pop de : dec e : dec d
    ;ok we need calculate kabum scr addr to clear a pixels
    ret

doMines:
	ld	b,MAXMINES
	ld	ix,minesList
.loop:	ld	a,(ix+OBJMINE.counter)
	or	a			; Is this mine active?
	jr	z,20f			; No, skip to next mine
	push	bc
	ld	de,(ix+OBJMINE.xPos)
	; dec counter and save
	dec	a
	ld	(ix+OBJMINE.counter),a
	jr	nz,4f			; Blink light if not ready
	call	playBumSound		; Explode mine
	ld	hl,(ix+OBJMINE.mapaddr)
	call	initKabum
	jr	10f
4:	; Make the mine light blink
	and	7
	jr	nz,10f    
	;swap	2 frames
	ld	a,(ix+OBJMINE.delay) : xor 1 : ld (ix+OBJMINE.delay),a
	jr	nz,1f
	; Turn the mine light off
	ld	a,TILE_MINE :		call fillTile
	call	playMineSound
	jr	10f
1:	; Turn the mine light on 
	ld	a,TILE_ACTIVEMINE :	call fillTile
10:	; Iteraction end
	pop	bc
20:	; Next mine
	ld	de,OBJMINE
	add	ix,de
	djnz	.loop
	ret

;   de - tile coords
;   hl - in map coords
addMine:
	;get mines pointer
	ld	ix,(minesPointer)
	
	;set initial parameters
	ld	(ix+OBJMINE.counter),100
	ld	(ix+OBJMINE.xPos),de
	ld	(ix+OBJMINE.mapaddr),hl

	;step to next if end of list loop to begin
	ld	bc,OBJMINE
	add	ix,bc
	ld	a,(ix+OBJMINE.counter)
	cp	255
	jr	c,1f
	ld	ix,minesList
1:
	ld	(minesPointer),ix
	ret
	
